# scrum-workshop

# O que é Scrum?

É um framework simples para gerenciar projetos

# Objetivo

  Ter controle e transparência durante o ciclo de desenvolvimento de um produto, através de iterações que tragam valores de negócio rapidamente.

  ![Como fazer](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/00.agilecar.png)

# Papéis

  1. **Product Owner:** Define o roadmap do produto e prioridade do que deve ser desenvolvido;
  2. **Scrum Master:** Garante que o scrum está sendo implementado da maneira certa, remove impedimentos, facilita a vida do time, mas não é chefe!
  3. **Devs!** Quem define como tudo será desenvolvido e põe a mão na massa. A idéia é que o time seja auto-suficiente e auto-gestor do projeto.

  ![Time](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/actors/scrum-team.jpg)

# Eventos e Cerimônias

  1. **Definição do backlog:**
    Definir e priorizar as histórias (funcionalidades) com o Scrum Master (coach) e o time, elegendo as de maior valor de negócio primeiro. Neste ponto, deve-se separar as funcionalidade em pelo menos 3 categorias (Imprescindível, Importante, seria bom ter).

  2. **Grooming, Planning e definição do Sprint**
    De acordo com a capacidade do time (quantidade), defini-se quanto é possível entregar a cada 10 dias úteis ou 1 mês trabalhado por pessoa;

  3. **Execução do Sprint:**
    Aqui tudo começa a ser desenvolvido!

  4. **Daily Meeting:**
    Diariamente. O que eu fiz. O que irei fazer. Existe algum impedimento? (Neste ponto, pode-se começar a utilizar o BurnDown e Kanbam - Que não fazem parte do Scrum, mas auxiliam).

  5. **Sprint Review:**
    Entrega do Sprint, junto com o Product Owner, que irá validar ou não a entrega.

  6. **Retrospectiva:**
    Reunião com o time e o Scrum Master após a entrega do Sprint para saber o que deu certo e o que pode ser melhorado e como melhorar.

## Visão Macro

![Ciclo](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/01.cycle.png)

### Então

  * É criado o **backlog**
  * Os Devs elegem as **histórias** para o **Sprint-Backlog** de acordo com as proridades definidas pelo **P.O.**.
    1. O time realiza um **Planning poker** para mensurar o **Sprint-Backlog**
  * **Time**, **Scrum Master** e **P.O.** fazem **Groomings** esclarecer as histórias (**1x ou 2x na semana, durante 1 hora no máximo**)
  * **Time** começa a trabalhar no **Sprint**
    1. **Time** e **Scrum Master** fazem o **daily meeting**
    2. **Scrum Master** ou o **Time** atualiza o **BurnDown**
  * **Time** e **Scrum Master** apresentam o resultado do **Sprint** ao **P.O.**
  * **Time** e **Scrum Master** fazem uma retrospectiva do **Sprint** (máximo de 1 hora)
  * Voltamos ao primeiro passo

# Ferramentas Auxiliares e métricas

## Planning Poker

  ![Planning Poker](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/02.planning-poker.jpg)
  
  Determina o esforço para desenvolver uma determinada tarefa, onde os desenvolvedores pontuam e dicutem como será implementada cada feature e assim fica possível mensurar a quantidade de tarefas que haverá no Sprint.
  * Sequência Fibonacci (?, 0, 1/2, 1, 2, 3, 5, 8, 13, 21)
  * Conceito de **Épico**!
  
## Kanban

  ![Kanban](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/03.kanban.jpg)

   O famoso TO-DO / Working / Testing / Done!

## Burn Down

  ![Burn Down](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/04.burndown.png)

  Mede o progresso do sprint e dá indicativos do processo de trabalho da equipe

## Velocidade do time

  ![Velocidade do Time](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/05.velocity.jpg)

  Aplicando o **Planning Poker** + **Burn Down**, após alguns Sprints, você terá a velocidade constante do time e assim poderá mensurar o desempenho individual. Dependendo da fase do projeto você saberá se é melhor adicionar ou remover pessoas do projeto para atingir determinado "goal"!

## Time boxing

  ![Velocidade do Time](https://raw.githubusercontent.com/zekitow/scrum-workshop/master/imgs/06.time-boxing.jpg)

  Apesar de haver muitas reuniões durante a utilização do Scrum o **time-boxing** para cada uma das cerimônias é algo primordial para manter o time focado e não perder tempo, pois a maioria das reuniões longas desviam-se do assunto principal.


# Por onde começar?

  1. Definir responsabilidades (P.O., Scrum Master, Time)
  2. Executar todas as cerimônias (Planning, Grooming, Daily, Review, Retrospectiva)
  3. Quantificar e acompanhar a evolução do Produto e Backlog
  4. Ter em mente que ferramentas **NÃO são mais importantes** que pessoas e processos
  5. Não planejar 100% do produto antes de iniciar o desenvolvimento
  6. Entender que ser ágil não é entregar rápido, mas sim, adaptar-se rapidamente
  7. Trabalhar em equipe
  8. Definir "DONE"
  9. Definir a pontuação
  10. Começar!

